Attribute VB_Name = "mdlAnimatedCursors"
Option Explicit

Private Type tICONINFO
    StructureSize As Long
    IsIcon As Long
    XHotspot As Long
    YHotspot As Long
    hBmpMask As Long
    hBmpColour As Long
End Type

Private Type tBITMAP '24 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Declare Function LoadCursorFromFile Lib "user32" Alias "LoadCursorFromFileA" (ByVal lpFileName As String) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function GetIconInfo Lib "user32" (ByVal hIcon As Long, Info As tICONINFO) As Long
Private Declare Function GetObjectA Lib "gdi32" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

Const DI_MASK = &H1
Const DI_IMAGE = &H2
Const DI_DEFAULTSIZE = &H8
Const DI_NORMAL = DI_MASK Or DI_IMAGE Or DI_DEFAULTSIZE
Public BmpInfo As tBITMAP

'These function read an animated and not animated cursors and put the subimage(s) in a picturebox
Public Function AnimatedCursor(AniFilePath As String, picDestany As Variant)
    Dim lngNewCursor As Long
    Dim result As Long
    Dim i As Long
    Dim IconInfo As tICONINFO
    
    If picDestany.Count > 1 Then
        For i = 1 To picDestany.Count - 1
            Unload picDestany(i)
        Next i
    End If
    picDestany(0).Cls
    i = 0
    lngNewCursor = LoadCursorFromFile(AniFilePath)
    If lngNewCursor Then
      
      GetIconInfo lngNewCursor, IconInfo
      GetObjectA IconInfo.hBmpMask, 24, BmpInfo
      
      Do
          If i > 0 Then Load picDestany(i)
          result = DrawIconEx(picDestany(i).hdc, 0, 0, lngNewCursor, BmpInfo.bmWidth, BmpInfo.bmHeight, i, 0, DI_NORMAL)
          If result = 0 Then
            Unload picDestany(i)
            Exit Do
        End If
          picDestany(i).Width = BmpInfo.bmWidth
          picDestany(i).Height = BmpInfo.bmHeight
          picDestany(i).Picture = picDestany(i).Image
          If UCase(AniFilePath) Like "*.CUR" Then Exit Do
          i = i + 1
      Loop While result <> 0
      DestroyCursor (lngNewCursor)
    End If
End Function
