Attribute VB_Name = "mdlMouseWheel"
' ///////////////////////////////////////////////
'  Return MouseWheel Over Multiple UserControls
'  Ed Wilk/Edgemeal
'  Example UPDATED September 18, 2008
' ///////////////////////////////////////////////
'
' ****************************************************
' IMPORTANT NOTICE:
'   To stop the hook from sending messages to a
'   window handle set the variable MouseOverControl
'   to zero!
' ****************************************************
' Completed and updated by Joaquim(or Cambalinho(same person;))
' Now these code is compactible with Horizontal and Vertical Wheel(touchpad and mouse)

Option Explicit
Private PrevWin2 As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FlatSB_SetScrollPos Lib "comctl32" (ByVal hwnd As Long, ByVal code As Long, ByVal nPos As Long, ByVal fRedraw As Boolean) As Long
Private Const GWL_WNDPROC = (-4)
Private Const WM_MOUSEWHEEL = &H20A
Private Const WM_VSCROLL As Long = &H115
Private Const WM_MOUSEHWHEEL = &H20E
Private Const WM_HSCROLL = &H114
Public MouseOverControl As Long ' Handle for User Control (mouse move)
Private Const WM_KEYDOWN = &H100
Private Const SB_HORZ = 0
Private Const SB_VERT = 1


Private Function Proc2(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If ((Msg = WM_MOUSEWHEEL Or Msg = WM_VSCROLL) And MouseOverControl > 0) Then
        If wParam / 65536 > 0 Then 'Down
            SendMessage MouseOverControl, WM_KEYDOWN, 1001, 0
        Else 'Up
            SendMessage MouseOverControl, WM_KEYDOWN, 1000, 0
        End If
    ElseIf ((Msg = WM_MOUSEHWHEEL Or Msg = WM_HSCROLL) And MouseOverControl > 0) Then
        If wParam / 65536 > 0 Then 'Right
            SendMessage MouseOverControl, WM_KEYDOWN, 1003, 0
            Debug.Print "oi"
        Else 'Left
            SendMessage MouseOverControl, WM_KEYDOWN, 1002, 0
        End If
    End If
    Proc2 = CallWindowProc(PrevWin2, hwnd, Msg, wParam, lParam)
End Function

Public Sub Hook2(handle As Long)
    If PrevWin2 = 0 Then
        PrevWin2 = SetWindowLong(handle, GWL_WNDPROC, AddressOf Proc2)
    End If
End Sub

Public Sub Unhook2(handle As Long)
    If PrevWin2 Then
        Call SetWindowLong(handle, GWL_WNDPROC, PrevWin2)
        PrevWin2 = 0
    End If
End Sub

Private Sub ChangeScroolPosition()
    FlatSB_SetScrollPos lngHWNDMouseWheel, SB_VERT, 2, False
    FlatSB_SetScrollPos lngHWNDMouseWheel, SB_HORZ, 2, False
End Sub
